Imports System.IO
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Data
Imports System.Data.SqlServerCe


Public Class frmRFIDData
    Const UpdateSql = "UPDATE [tblDaten] SET [VarField1] = @p1, [VarField2] = @p2, [VarField3] = @p3, [VarField4] = @p4, [VarField5] = @p5 " ' WHERE ([VarField1] = @p1)"
    Const InsertSql = "INSERT INTO [tblDaten] ([VarField1], [VarField2], [VarField3], [VarField4], [VarField5]) VALUES (@p1, @p2, @p3, @p4, @p5)"

    Dim DBStatus As String
    Dim thisDate As Date
    Public TagInfo As String

    Public frmDataDlg As frmData

    Private Sub ExitItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitItem.Click
        If MsgBox("Close Form ?", MsgBoxStyle.YesNo, Text) = MsgBoxResult.Yes Then
            Close()
        End If
    End Sub

    Private Sub DataItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DataItem.Click
        Dim rcount As Integer
        Dim frmDataDlg As New frmData
        fc.CloseConnection()
        fc.OpenConnection()
        If fc.conn_bar.State = ConnectionState.Open Then
            fc.SC(1)
            frmDataDlg.DataGrid1.DataSource = Nothing
            'DataGrid1.DataSource = Nothing
            rcount = fc.GetRecordCount
            frmDataDlg.CountLabel1.Text = rcount.ToString
            frmDataDlg.LabelI1.Text = "Data:"
            If rcount > 0 Then
                'SetPanel(4)
                fc.cmd_bar.CommandText = "Select * from tblDaten"
                fc.rs_bar.SelectCommand = fc.cmd_bar
                fc.ds_bar.Clear()
                fc.rs_bar.Fill(fc.ds_bar, "tblDaten")
                frmDataDlg.DataGrid1.ColumnHeadersVisible = True
                frmDataDlg.DataGrid1.DataSource = fc.ds_bar.Tables("tblDaten")
            Else
                'frmDataDlg.bbDatenLoeschen.Enabled = False
            End If
            fc.SC(0)
            frmDataDlg.ShowDialog()
            If Not frmDataDlg Is Nothing Then
                frmDataDlg.Dispose()
                frmDataDlg = Nothing
            End If
        End If
    End Sub

    Private Function FindTAGInTable(ByVal TagNr As String) As Boolean
        Dim Sql As String
        Dim s As Date = Now
        Dim rcount As Integer
        FindTAGInTable = False
        fc.CloseConnection()
        fc.OpenConnection()
        If fc.conn_bar.State = ConnectionState.Open Then
            Sql = "SELECT * FROM tblDaten WHERE VarField1 = '" & TagNr & "'"
            fc.cmd_bar.CommandText = Sql
            fc.rs_bar.SelectCommand = fc.cmd_bar
            fc.ds_bar.Clear()
            rcount = fc.rs_bar.Fill(fc.ds_bar, "tblDaten")
            If rcount > 0 Then
                Dim dr_auf As DataRow = fc.ds_bar.Tables("tblDaten").NewRow()
                dr_auf = fc.ds_bar.Tables("tblDaten").Select("VarField1='" & TagNr & "'")(0)
                FindTAGInTable = True
                If (fc.TagType = 1) Or (fc.TagType = 3) Then ' The data comes from Transponder
                    ' txtBox2.Text = dr_auf("VarField2").ToString
                Else
                    txtBox2.Text = dr_auf("VarField2").ToString
                End If
                txtBox3.Text = dr_auf("VarField3").ToString
                txtBox4.Text = dr_auf("VarField4").ToString
                txtBox5.Text = dr_auf("VarField5").ToString
                dr_auf = Nothing
                fc.CloseConnection()
            End If
        End If
    End Function

    Private Function ReadTagDataHF() As Boolean
        Dim tmpField1 As String
        Dim Result As Boolean
        Dim Res1, Res2 As String
        Result = False
        Res1 = ""
        Res2 = ""
        tmpField1 = ""

        If fc.HF_Reader_Typ = 0 Then
            If fc.RFID.ReadTagBlock(10, 2, 0) Then
                tmpField1 = fc.RFID.BlockDataAScII
            End If
        End If

        If fc.HF_Reader_Typ = 1 Then
            fc.RFID.SelectMifare()
            fc.RFID.SetKeyMifare(2)
            If fc.RFID.ReadMifare(2, 1, 0) Then
                tmpField1 = fc.RFID.BlockDataAScII
            End If
        End If
        txtBox2.Text = tmpField1
        Return Result
    End Function

    Private Function ReadTagDataLF() As Boolean
        Dim tmpField1 As String
        Dim Result As Boolean
        Dim Res1, Res2 As String
        Result = False
        Res1 = ""
        Res2 = ""
        tmpField1 = ""
        Select Case fc.TagType
            Case 1 ' HitagS
                Res1 = fc.MyBTLF.ReadTagData(fc.TagType, 10)
                Res2 = fc.MyBTLF.ReadTagData(fc.TagType, 11)
                If (Res1.Length >= 8) And (Res2.Length >= 8) Then
                    tmpField1 = Res1 & Res2
                    Result = True
                End If
                tmpField1 = fc.MyBTLF.HexToASCII(tmpField1)
                txtBox2.Text = tmpField1
            Case 3 ' Q5/5557
                Res1 = fc.MyBTLF.ReadTagData(fc.TagType, 10)
                Res2 = fc.MyBTLF.ReadTagData(fc.TagType, 11)
                If (Res1.Length >= 8) And (Res2.Length >= 8) Then
                    tmpField1 = Res1 & Res2
                    Result = True
                End If
                tmpField1 = fc.MyBTLF.HexToASCII(tmpField1)
                txtBox2.Text = tmpField1
            Case 7 ' EM4450/4550 (TITAN)-RW
                Res1 = fc.MyBTLF.ReadTagData(fc.TagType, 10)
                Res2 = fc.MyBTLF.ReadTagData(fc.TagType, 11)
                If (Res1.Length >= 8) And (Res2.Length >= 8) Then
                    tmpField1 = Res1 & Res2
                    Result = True
                End If
                tmpField1 = fc.MyBTLF.HexToASCII(tmpField1)
                txtBox2.Text = tmpField1
        End Select
        Return Result
    End Function

    Private Function WriteTagDataHF() As Boolean
        Dim Result As Boolean
        Dim tmpField1 As String
        Dim i As Integer
        Result = False
        tmpField1 = txtBox2.Text

        If fc.HF_Reader_Typ = 1 Then
            For i = tmpField1.Length To 8 - 1
                tmpField1 = tmpField1 & " "
            Next
            If tmpField1.Length = 16 Then
                fc.RFID.SelectMifare()
                fc.RFID.SetKeyMifare(2)
                Result = fc.RFID.WriteMifare(2, 1, tmpField1, 0)
            End If
        Else
            For i = tmpField1.Length To 8 - 1
                tmpField1 = tmpField1 & " "
            Next
            'tmpField1 = fc.RFID.ASCIIToHex(tmpField1)
            If tmpField1.Length = 8 Then
                Result = fc.RFID.WriteTagBlock(10, 2, tmpField1, 0)
            End If
        End If

        Return Result
    End Function

    Private Function WriteTagDataLF() As Boolean
        '0 - EM 41xx (UNIQUE) - RO
        '1 - HITAG S - RW
        '2 - FDX-B ISO 11784/5-RO
        '3 - Q5 / 5557 -- RW
        '4 - HDX Transponder (TI)-RW
        '5 - HITAG 2 - RW
        '6 - EM 4305 - RW
        '7 - EM4450/4550 (TITAN)-RW

        Dim tmpField1 As String
        Dim Result As Boolean
        Dim Res1, Res2 As String
        Dim i As Integer
        Result = False
        Res1 = ""
        Res2 = ""
        Select Case fc.TagType
            Case 1 ' HitagS
                tmpField1 = txtBox2.Text
                For i = tmpField1.Length To 8 - 1
                    tmpField1 = tmpField1 & " "
                Next
                tmpField1 = fc.MyBTLF.ASCIIToHex(tmpField1)
                If tmpField1.Length = 16 Then
                    Res1 = fc.MyBTLF.WriteTagData(fc.TagType, 10, tmpField1.Substring(0, 8))
                    Res2 = fc.MyBTLF.WriteTagData(fc.TagType, 11, tmpField1.Substring(8, 8))
                End If
            Case 3 ' Q5/5557
                tmpField1 = txtBox2.Text
                For i = tmpField1.Length To 8 - 1
                    tmpField1 = tmpField1 & " "
                Next
                tmpField1 = fc.MyBTLF.ASCIIToHex(tmpField1)
                If tmpField1.Length = 16 Then
                    Res1 = fc.MyBTLF.WriteTagData(fc.TagType, 10, tmpField1.Substring(0, 8))
                    Res2 = fc.MyBTLF.WriteTagData(fc.TagType, 11, tmpField1.Substring(8, 8))
                End If
            Case 7 'EM4450/4550 (TITAN)-RW
                tmpField1 = txtBox2.Text
                For i = tmpField1.Length To 8 - 1
                    tmpField1 = tmpField1 & " "
                Next
                tmpField1 = fc.MyBTLF.ASCIIToHex(tmpField1)
                If tmpField1.Length = 16 Then
                    Res1 = fc.MyBTLF.WriteTagData(fc.TagType, 10, tmpField1.Substring(0, 8))
                    Res2 = fc.MyBTLF.WriteTagData(fc.TagType, 11, tmpField1.Substring(8, 8))
                End If
        End Select
        Result = (Res1 = "+") And (Res2 = "+")
        Return Result
    End Function

    Private Function WriteDataToDataBase(ByVal TagNr As String) As Boolean
        Dim tmpTAG = TagNr
        Dim IsNewDataSet As Boolean
        Dim s As Date = Now
        Dim rcount As Integer
        WriteDataToDataBase = False
        IsNewDataSet = DBStatus = "AddNew"

        fc.CloseConnection()
        fc.OpenConnection()
        If Not (fc.conn_bar.State = ConnectionState.Open) Then
            fc.CloseConnection()
            Exit Function
        End If

        fc.cmd_bar.CommandText = "SELECT * FROM tblDaten WHERE VarField1 = '" & TagNr & "'"
        fc.rs_bar.SelectCommand = fc.cmd_bar

        Dim cb As New SqlCeCommandBuilder(fc.rs_bar)
        fc.rs_bar.InsertCommand = cb.GetInsertCommand
        fc.rs_bar.UpdateCommand = cb.GetInsertCommand
        fc.rs_bar.UpdateCommand.CommandText = UpdateSql & " WHERE ([VarField1] = '" & TagNr & "')"

        fc.ds_bar.Clear()
        rcount = fc.rs_bar.Fill(fc.ds_bar, "tblDaten")

        If Not IsNewDataSet Then
            If rcount = 0 Then
                fc.CloseConnection()
                Exit Function
            End If
        End If

        Dim dr_auf As DataRow = fc.ds_bar.Tables("tblDaten").NewRow()

        If Not IsNewDataSet Then
            dr_auf = fc.ds_bar.Tables("tblDaten").Select("VarField1='" & TagNr & "'")(0)
        End If
        txtBox5.Text = s.ToShortTimeString
        dr_auf("VarField1") = TagNr
        dr_auf("VarField2") = txtBox2.Text
        dr_auf("VarField3") = txtBox3.Text
        dr_auf("VarField4") = txtBox4.Text
        dr_auf("VarField5") = txtBox5.Text

        If IsNewDataSet Then
            fc.ds_bar.Tables("tblDaten").Rows.Add(dr_auf)
        End If
        fc.rs_bar.Update(fc.ds_bar, "tblDaten")
        dr_auf = Nothing
        cb.Dispose()
        cb = Nothing
        WriteDataToDataBase = True
    End Function

    Private Sub GetDataFromDatabase(ByVal TagNr As String)
        If Not FindTAGInTable(TagNr) Then
            DBStatus = "AddNew"
            thisDate = Today
            txtBox5.Text = thisDate.ToShortDateString
        Else
            DBStatus = "Edit"
        End If
    End Sub

    Private Sub btReadTag_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btReadTag.Click
        Dim TagNr As String
        Try
            fc.SC(1)
            lbInfo1.Text = TagInfo
            lbInfo1.Refresh()
            If fc.Reader_Typ = 1 Then
                TagNr = fc.MyBTLF.SelectTag(fc.TagType)
                If fc.MyBTLF.IsTagSelect Then
                    fc.PlaySound()
                    TextBoxAvtive(True)
                    txtBox1.Text = TagNr
                    ButtonActive(2)
                    ReadTagDataLF()
                    GetDataFromDatabase(TagNr)
                    txtBox2.Focus()
                Else
                    TextBoxAvtive(False)
                    txtBox1.Text = "No Tag found"
                    ButtonActive(1)
                    lbInfo1.Text = "No " & lbInfo1.Text & " found"
                    lbInfo1.Refresh()
                End If
            End If
            If fc.Reader_Typ = 2 Then
                fc.RFID.CheckReaderCTS()
                If fc.RFID.GetUID Then
                    fc.PlaySound()
                    TagNr = fc.RFID.UIDNr
                    TextBoxAvtive(True)
                    txtBox1.Text = TagNr
                    ButtonActive(2)
                    ReadTagDataHF()
                    GetDataFromDatabase(TagNr)
                    txtBox2.Focus()
                Else
                    TextBoxAvtive(False)
                    txtBox1.Text = "No Tag found"
                    ButtonActive(1)
                    lbInfo1.Text = "No " & lbInfo1.Text & " found"
                    lbInfo1.Refresh()
                End If
            End If
            If fc.Reader_Typ = 3 Then
                fc.RFID.CheckReaderCTS()
                If fc.RFID.GetUID Then
                    fc.PlaySound()
                    TagNr = fc.RFID.UIDNr
                    TextBoxAvtive(True)
                    txtBox1.Text = TagNr
                    ButtonActive(2)
                    ReadTagDataHF()
                    GetDataFromDatabase(TagNr)
                    txtBox2.Focus()
                Else
                    TextBoxAvtive(False)
                    txtBox1.Text = "No Tag found"
                    ButtonActive(1)
                    lbInfo1.Text = "No " & lbInfo1.Text & " found"
                    lbInfo1.Refresh()
                End If
            End If
        Finally
            fc.SC(0)
        End Try
    End Sub

    Private Sub frmRFIDData_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        fc.CloseConnection()
    End Sub

    Private Sub frmRFIDData_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        TextBoxAvtive(False)
        ButtonActive(0)
        If fc.Reader_Typ = 1 Then
            If fc.MyBTLF.Active Then
                btReadTag.Enabled = True
                btWrite.Enabled = False
                btCancel.Enabled = False
                ButtonActive(1)
            End If
        End If
        If fc.Reader_Typ = 2 Then
            If fc.RFID.IsActive Then
                btReadTag.Enabled = True
                btWrite.Enabled = False
                btCancel.Enabled = False
                ButtonActive(1)
            End If
        End If
        If fc.Reader_Typ = 3 Then
            If fc.RFID.IsActive Then
                btReadTag.Enabled = True
                btWrite.Enabled = False
                btCancel.Enabled = False
                ButtonActive(1)
            End If
        End If
    End Sub

    Private Sub ButtonActive(ByVal Index As Integer)
        Select Case Index
            Case 0
                btReadTag.Enabled = False
                btCancel.Enabled = False
                btWrite.Enabled = False
                DataItem.Enabled = False
            Case 1
                btReadTag.Enabled = True
                btCancel.Enabled = False
                btWrite.Enabled = False
                DataItem.Enabled = True
            Case 2
                btReadTag.Enabled = False
                btCancel.Enabled = True
                btWrite.Enabled = True
            Case 3
                btReadTag.Enabled = True
                btCancel.Enabled = True
                btWrite.Enabled = True
                DataItem.Enabled = True
        End Select

    End Sub

    Private Sub TextBoxAvtive(ByVal Active As Boolean)
        txtBox1.Enabled = Active
        txtBox2.Enabled = Active
        txtBox3.Enabled = Active
        txtBox4.Enabled = Active
        txtBox5.Enabled = Active
    End Sub

    Private Sub btCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btCancel.Click
        fc.CloseConnection()
        TextBoxAvtive(False)
        ButtonActive(1)
    End Sub

    Private Sub ClearTextBoxes()
        txtBox1.Text = ""
        txtBox2.Text = ""
        txtBox3.Text = ""
        txtBox4.Text = ""
        txtBox5.Text = ""
    End Sub

    Private Sub btWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btWrite.Click
        Dim TagNr As String
        Try
            btWrite.Enabled = False
            fc.SC(1)
            TagNr = txtBox1.Text
            If fc.Reader_Typ = 1 Then
                WriteTagDataLF()
                WriteDataToDataBase(TagNr)
                ClearTextBoxes()
                TextBoxAvtive(False)
                ButtonActive(1)
                fc.PlaySound()
            End If
            If fc.Reader_Typ = 2 Then
                fc.RFID.CheckReaderCTS()
                WriteTagDataHF()
                WriteDataToDataBase(TagNr)
                ClearTextBoxes()
                TextBoxAvtive(False)
                ButtonActive(1)
                fc.PlaySound()
            End If
            If fc.Reader_Typ = 3 Then
                fc.RFID.CheckReaderCTS()
                WriteTagDataHF()
                WriteDataToDataBase(TagNr)
                ClearTextBoxes()
                TextBoxAvtive(False)
                ButtonActive(1)
                fc.PlaySound()
            End If
        Finally
            'btWrite.Enabled = True
            fc.SC(0)
        End Try
    End Sub
End Class